
static Widget creer_bouton(char *nom, Widget pere, int bordWidth)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, 
				 XmNwidth, BUTTON_WIDTH,
				 XmNborderWidth, bordWidth, 
				 XmNlabelString, XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), 
				 NULL));
}

static void mk_pace_control(Widget w)
{
  Widget widg1, t_widg, widg;

  // UP/TICK button
  t_widg = creer_bouton("UP/TICK", w, 2);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT, 
		XmNtopAttachment, XmATTACH_FORM, 
		XmNrightAttachment, XmATTACH_FORM, 
		NULL);
  XtAddCallback(t_widg, XmNactivateCallback, (XtCallbackProc)inter_up, NULL);
  
  // AUTO/MANU button
  widg =XtVaCreateManagedWidget("AUTO/MANU", xmPushButtonWidgetClass, w, 
				XmNwidth, BUTTON_WIDTH,
				XmNborderWidth, 1, XmNlabelString, 
				XmStringCreateLtoR("AUTO/MANU", XmSTRING_DEFAULT_CHARSET), 
				XmNx, pmauto_X,
				XmNy, pmauto_Y,
				NULL);
  XtAddCallback(widg, XmNactivateCallback, (XtCallbackProc)inter_auto, NULL);
  //  auto_creat(widg);

  //DOWN/QUIT button
  widg1 = creer_bouton("DOWN/QUIT", w, 2);
  XtVaSetValues(widg1, XmNheight, BUTTON_HEIGHT,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, widg,
		XmNrightAttachment, XmATTACH_FORM, 
		XmNrightAttachment, XmATTACH_FORM, 
		NULL);

  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)inter_down, NULL);
}


static void mk_left_buttons(Widget pere)
{
  Widget    w1, w2;

  // UL button
  w1 =XtVaCreateManagedWidget("UL", xmPushButtonWidgetClass, pere, 
			      XmNwidth, BUTTON_HEIGHT,
			      XmNborderWidth, 1, 
			      XmNlabelString, XmStringCreateLtoR("UL", XmSTRING_DEFAULT_CHARSET), 
			      XmNy, PL_Y_U, 
			      NULL);
   XtVaSetValues(w1,  XmNheight, BUTTON_HEIGHT, NULL);
  XtAddCallback(w1, XmNactivateCallback, (XtCallbackProc)inter_ul, NULL);
    
  // LL button
  w2 =XtVaCreateManagedWidget("LL", xmPushButtonWidgetClass, pere, 
			      XmNwidth, BUTTON_HEIGHT,
			      XmNborderWidth, 1, 
			      XmNlabelString, XmStringCreateLtoR("LL", XmSTRING_DEFAULT_CHARSET), 
			      XmNy, PL_Y_L, 
			      NULL);
  XtVaSetValues(w2, XmNheight, BUTTON_HEIGHT, NULL);
  XtAddCallback(w2, XmNactivateCallback, (XtCallbackProc)inter_ll, NULL);
}


static void mk_right_buttons(Widget pere)
{
  Widget    w1, w2;

  // UR button
  w1 =XtVaCreateManagedWidget("UR", xmPushButtonWidgetClass, pere, 
			      XmNwidth, BUTTON_HEIGHT,
			      XmNborderWidth, 1, 
			      XmNlabelString, XmStringCreateLtoR("UR", XmSTRING_DEFAULT_CHARSET), 
			      XmNy, PL_Y_U, 
			      NULL);
  XtVaSetValues(w1,  XmNheight, BUTTON_HEIGHT, NULL);
  XtAddCallback(w1, XmNactivateCallback, (XtCallbackProc)inter_ur, NULL);
    
  // LR button
  w2 =XtVaCreateManagedWidget("LR", xmPushButtonWidgetClass, pere, 
			      XmNwidth, BUTTON_HEIGHT,
			      XmNborderWidth, 1, 
			      XmNlabelString, XmStringCreateLtoR("LR", XmSTRING_DEFAULT_CHARSET),
			      XmNy, PL_Y_L,
			      NULL);
  XtVaSetValues(w2, XmNheight, BUTTON_HEIGHT, NULL);
  XtAddCallback(w2, XmNactivateCallback, (XtCallbackProc)inter_lr, NULL);
}

static void creation_id(Widget w)
{
  Widget panel_cadre, panel_gauche_widg, widg, panel_droit_widg;

  panel_cadre = XtVaCreateManagedWidget("panel_cadre", xmFormWidgetClass, w, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNverticalSpacing, ESP_HEIGHT, 
					NULL);
  
  panel_gauche_widg = XtVaCreateManagedWidget("panel_gauche", xmFormWidgetClass, panel_cadre,
					      XmNborderWidth, 1,
					      XmNtopAttachment, XmATTACH_FORM,
					      XmNbottomAttachment, XmATTACH_FORM,
					      XmNverticalSpacing, ESP_HEIGHT,
					      NULL);
  mk_left_buttons(panel_gauche_widg);


  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass , panel_cadre, 
				 XmNborderWidth, 1,
				 XmNwidth, CANVAS_WIDTH, 
				 XmNheight, CANVAS_HEIGHT, 
				 XmNtopAttachment, XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_FORM,
				 XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, panel_gauche_widg,
				 NULL);
  canvas_creat(widg);

  panel_droit_widg = XtVaCreateManagedWidget("panel_droit", xmFormWidgetClass, panel_cadre,
					     XmNborderWidth, 1,
					     XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg,
					     XmNtopAttachment, XmATTACH_FORM,
					     XmNbottomAttachment,  XmATTACH_FORM,
					     XmNverticalSpacing, ESP_HEIGHT,
					     NULL);
  mk_right_buttons(panel_droit_widg);
  }


/*------------------------------------------------------------------------------
  Creating thr main window.
  ------------------------------------------------------------------------------*/
static void mk_main_window(Widget toplevel)
{
  Widget pace_maker_widg, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);

  appli_widg = XtVaCreateManagedWidget(PROGNAME, xmFormWidgetClass, frame_widg, 
				       XmNtopAttachment,  XmATTACH_FORM, 
				       XmNleftAttachment, XmATTACH_FORM, 
				       XmNrightAttachment, XmATTACH_FORM, 
				       NULL);
  creation_id(appli_widg);
  
  pace_maker_widg = XtVaCreateManagedWidget("pace_maker", xmFormWidgetClass, frame_widg,
					    XmNborderWidth, 1, 
					    XmNwidth, pmWIDTH_panel, 
					    XmNheight, pmHEIGHT_panel, 
					    XmNleftAttachment, XmATTACH_FORM, 
					    XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, appli_widg, 
					    XmNbottomAttachment, XmATTACH_FORM, 
					    NULL);
  mk_pace_control(pace_maker_widg);
}
