
static Widget creer_label(char *nom, Widget pere, int vY)
{
  return(XtVaCreateManagedWidget(nom, xmLabelWidgetClass, pere,
				 XmNlabelString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), 
				 XmNwidth, LABEL_WIDTH, 
				 XmNy, vY,
				 XmNheight, BUTTON_HEIGHT,
				 NULL));
}


static Widget creer_bouton(char *nom, Widget pere, int bordWidth)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, XmNwidth, BUTTON_WIDTH,
				 XmNborderWidth, bordWidth, XmNlabelString, 
				XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), NULL));
}

static Widget creer_jauge(char *nom, Widget pere, int min, int max)
{
  return(XtVaCreateManagedWidget(nom, xmScaleWidgetClass, pere, XmNtitleString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 XmNminimum, min, XmNmaximum, max, XmNshowValue, TRUE, 
				 XmNorientation, XmHORIZONTAL, XmNscaleHeight, 40, 
				 XmNscaleWidth, 200, NULL));
}


static void mk_pace_control(Widget w)
{
  Widget widg1, t_widg, widg;

  // UP/TICK button
  t_widg = creer_bouton("UP/TICK", w, 2);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(t_widg, XmNactivateCallback, (XtCallbackProc)inter_up, NULL);
  
  // AUTO/MANU button
  widg =XtVaCreateManagedWidget("AUTO/MANU", xmPushButtonWidgetClass, w, XmNwidth, BUTTON_WIDTH,
				XmNborderWidth, 1, 
				XmNlabelString, XmStringCreateLtoR("AUTO/MANU", XmSTRING_DEFAULT_CHARSET), 
				XmNx, pmauto_X,
				XmNy, pmauto_Y,
				NULL);
  
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT, 
		// XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_WIDGET, 
		XmNrightWidget, t_widg, NULL);
  XtAddCallback(widg, XmNactivateCallback, (XtCallbackProc)inter_auto, NULL);
  //  auto_creat(widg);

  //DOWN/QUIT button
  widg1 = creer_bouton("DOWN/QUIT", w, 2);
  XtVaSetValues(widg1, XmNheight, BUTTON_HEIGHT,
		XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, widg,
		XmNrightAttachment, XmATTACH_FORM, 
		NULL);

  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)inter_down, NULL);
}

static void mk_pace_maker(Widget w)
{
  Widget  control_widg;

  control_widg = XtVaCreateManagedWidget("pace_control", xmFormWidgetClass, w, 
					XmNborderWidth, 1,
					XmNtopAttachment, XmATTACH_FORM, 
					XmNrightAttachment, XmATTACH_FORM,
					XmNleftAttachment, XmATTACH_FORM,
					NULL);
  mk_pace_control(control_widg);
}

static void mkLeftPanel(Widget pere)
{
  Widget w1, w2;
 
  w1 = creer_label("STATE", pere, PL_Y_W0);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_FORM, XmNrightAttachment, XmATTACH_FORM, NULL);
  w2 = creer_label("UR", pere, PL_Y_W1);
  w1 = creer_label("LR", pere, PL_Y_W2);
  w2 = creer_label("LL", pere, PL_Y_W3);
  w1 = creer_label("ON", pere, PL_Y_SW0);
  w2 = creer_label("UR", pere,  PL_Y_SW1);
  w1 = creer_label("LR", pere, PL_Y_SW2);
  w2 = creer_label("STATE", pere, PL_Y_A0);
  w1 = creer_label("UR", pere, PL_Y_A1);
  w2 = creer_label("LR", pere, PL_Y_A2);
  w1 = creer_label("LL", pere, PL_Y_A3);
  w2 = creer_label("BEEP", pere, PL_Y_HH0);
  w1 = creer_label("HS", pere, PL_Y_HH1);
  w2 = creer_label("HF", pere, PL_Y_HH2);
}


static void mk_appli_widget(Widget w)
{
  Widget panel_cadre, panel_gauche_widg, widg, panel_input_widg;

  panel_cadre = XtVaCreateManagedWidget("panel_cadre", xmFormWidgetClass, w, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNverticalSpacing, ESP_HEIGHT, NULL);
  
  panel_gauche_widg = XtVaCreateManagedWidget("panel_gauche", xmFormWidgetClass, panel_cadre,
					      XmNborderWidth, 1,
					      XmNtopAttachment, XmATTACH_FORM,
					      XmNbottomAttachment, XmATTACH_FORM,
					      // XmNx, x_panel, 
					      XmNverticalSpacing, ESP_HEIGHT, NULL);
  mkLeftPanel(panel_gauche_widg);
  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, panel_cadre, 
				 XmNborderWidth, 1, 
				 XmNwidth, screen_x, 
				 XmNheight, screen_y, 
				 XmNtopAttachment, XmATTACH_FORM,
				 // XmNbottomAttachment,  XmATTACH_FORM,
				 XmNleftAttachment, XmATTACH_WIDGET, 
				 XmNleftWidget, panel_gauche_widg, NULL);
  canvas_creat(widg);
}



static void mkButtons(Widget pere)
{

  Widget    wul, wll, wlr, wur, wbe;

  // UL button
  wul =XtVaCreateManagedWidget("UL", xmPushButtonWidgetClass, pere, 
			       XmNwidth, BUTTON_HEIGHT,
			       XmNborderWidth, 1, 
			       XmNlabelString, XmStringCreateLtoR("UL", XmSTRING_DEFAULT_CHARSET), 
			       //			       XmNx, PL_X_UL, 
			       //			       XmNy, PL_Y_UL, 
			       NULL);
  XtVaSetValues(wul, XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(wul, XmNactivateCallback, (XtCallbackProc)inter_ul, NULL);
    
  // LL button
  wll =XtVaCreateManagedWidget("LL", xmPushButtonWidgetClass, pere, 
			       XmNwidth, BUTTON_HEIGHT,
			       XmNborderWidth, 1, 
			       XmNlabelString, XmStringCreateLtoR("LL", XmSTRING_DEFAULT_CHARSET), 
			       NULL);
  XtVaSetValues(wll, XmNleftAttachment, XmATTACH_FORM,
		XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, wul,
		NULL);
  XtAddCallback(wll, XmNactivateCallback, (XtCallbackProc)inter_ll, NULL);

  // UR button
  wur =XtVaCreateManagedWidget("UR", xmPushButtonWidgetClass, pere, 
			       XmNwidth, BUTTON_HEIGHT,
			       XmNborderWidth, 1, 
			       XmNlabelString, XmStringCreateLtoR("UR", XmSTRING_DEFAULT_CHARSET), 
			       NULL);
  XtVaSetValues(wur,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, wul,
		NULL);
  XtAddCallback(wur, XmNactivateCallback, (XtCallbackProc)inter_ur, NULL);
    
  // LR button
  wlr =XtVaCreateManagedWidget("LR", xmPushButtonWidgetClass, pere, 
			       XmNwidth, BUTTON_HEIGHT,
			       XmNborderWidth, 1, 
			       XmNlabelString, XmStringCreateLtoR("LR", XmSTRING_DEFAULT_CHARSET),
			       NULL);
  XtVaSetValues(wlr,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, wll,
		XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, wur,
		NULL);
  XtAddCallback(wlr, XmNactivateCallback, (XtCallbackProc)inter_lr, NULL);

  // Bell button
  wbe =XtVaCreateManagedWidget("BE", xmPushButtonWidgetClass, pere, 
			       XmNwidth, BUTTON_HEIGHT,
			       XmNborderWidth, 1, 
			       XmNlabelString, XmStringCreateLtoR("BE", XmSTRING_DEFAULT_CHARSET),
			       NULL);
  XtVaSetValues(wbe,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, wlr,
		NULL);
  XtAddCallback(wbe, XmNactivateCallback, (XtCallbackProc)inter_ru, NULL);

}


static void mk_button_panel(Widget pere)
{
  Widget  control_widg;

  control_widg = XtVaCreateManagedWidget("button_control", xmFormWidgetClass, pere, 
					 XmNborderWidth, 1,
					 XmNwidth, 3*BUTTON_HEIGHT + 4,					 
					 XmNtopAttachment, XmATTACH_FORM, 
					 XmNrightAttachment, XmATTACH_FORM,
					 XmNleftAttachment, XmATTACH_FORM,
					 NULL);
  mkButtons(control_widg);
}


/*------------------------------------------------------------------------------
  Creating the main window.
 ------------------------------------------------------------------------------*/
static void mk_main_window(Widget toplevel)
{
  Widget buttonPanel, pace_maker_widg, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);
  appli_widg = XtVaCreateManagedWidget(PROGNAME, xmFormWidgetClass, frame_widg, 
				      XmNtopAttachment,  XmATTACH_FORM, 
				      XmNleftAttachment, XmATTACH_FORM, 
				      XmNrightAttachment, XmATTACH_FORM, NULL);
  mk_appli_widget(appli_widg);

  buttonPanel = XtVaCreateManagedWidget("buttonPanel", xmFormWidgetClass, frame_widg,
					XmNleftAttachment, XmATTACH_FORM, 
					XmNtopAttachment, XmATTACH_WIDGET, 
					XmNtopWidget, appli_widg, 
					XmNbottomAttachment, XmATTACH_FORM, NULL);
  mk_button_panel(buttonPanel);
  
  pace_maker_widg = XtVaCreateManagedWidget("pace_maker", xmFormWidgetClass, frame_widg, 
					    XmNrightAttachment, XmATTACH_FORM, 
					    XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, appli_widg, 
					    XmNbottomAttachment, XmATTACH_FORM, NULL);
  mk_pace_maker(pace_maker_widg);
}
