process VTWATCH =
     { integer M1, M2, PS, PISET, NAL, PERCENT, ST24_STR, PM_STR, DAY_STR, MONTH_STR, TICK_WIDTH; }
     ( ? event HE;
     )
   (| (| (| LR := SLR
          | UR := SUR
          | LL := SLL
          | UL := SUL
          | HS := HSLOW
          | HF := HCHRONO
          | WACHAL{PS,PISET,NAL}
          |) where event HF, HS, UL, LL, UR, LR; end
       | (| CONTEXT{M1,M2} |)/ ULLULR
       | SCREEN{ST24_STR,7*TICK_WIDTH,10*TICK_WIDTH,3*TICK_WIDTH,PM_STR,DAY_STR,MONTH_STR,TICK_WIDTH}
       | SIGBELL(PERCENT when (TBEEP default BEEP))
       |)/ SLR, SUR, SLL, SUL, HSLOW, HCHRONO, TBEEP, STNB, STATE24, DR, DM, DL, DPM, DYEAR, DMONTH, DDAYOFW, DDAY, LWHOUR, LWMIN, BEEP |)
   where 
   use LocLib, CONTEXT, GraphicLib; 
   process SCREEN =
        { integer ST24_STR, DTIME_X, DMTIME_Y, DLWTIME_Y, PM_STR, DAY_STR, MONTH_STR, TICK_WIDTH; }
        ( ? integer LWMIN;
            integer LWHOUR;
            integer DDAY;
            integer DDAYOFW;
            integer DMONTH;
            integer DYEAR;
            boolean DPM;
            integer DL;
            integer DM;
            integer DR;
            boolean STATE24;
            integer STNB;
        )
      (| (| DHOUR := LWHOUR
          | DMIN := LWMIN
          | LWSCREEN{DTIME_X,DLWTIME_Y,DAY_STR,MONTH_STR,TICK_WIDTH}
          |) where integer DMIN, DHOUR; end
       | TIMESCREEN{DTIME_X,DMTIME_Y,PM_STR,TICK_WIDTH}
       | WTAG{DTIME_X-(5*TICK_WIDTH),DMTIME_Y-(TICK_WIDTH/2),3*TICK_WIDTH,TICK_WIDTH,ST24_STR}(STATE24)
       | WINTTAG{TICK_WIDTH,DLWTIME_Y,4*TICK_WIDTH,2*TICK_WIDTH}(STNB)
       |)
      where 
      process LWSCREEN =
           { integer DTIME_X, DLWTIME_Y, DAY_STR, MONTH_STR, TICK_WIDTH; }
           ( ? integer DMIN;
               integer DHOUR;
               integer DDAY;
               integer DDAYOFW;
               integer DMONTH;
               integer DYEAR;
           )
         (| (| DMTH := DMONTH
             | (| GWINTTAG{DTIME_X-TICK_WIDTH,DLWTIME_Y,3*TICK_WIDTH,2*TICK_WIDTH,MONTH_STR}(DMTH)
                | WUNIT4{DTIME_X-(6*TICK_WIDTH),DLWTIME_Y,TICK_WIDTH}(DYEAR)
                |)
             |) where integer DMTH; end
          | (| WUNIT{DTIME_X+(3*TICK_WIDTH),DLWTIME_Y,TICK_WIDTH}(DHOUR)
             | WUNIT{DTIME_X+(6*TICK_WIDTH),DLWTIME_Y,TICK_WIDTH}(DMIN)
             |)
          | (| DDW := DDAYOFW
             | DD := DDAY
             | (| WUNIT{DTIME_X+(3*TICK_WIDTH),DLWTIME_Y,TICK_WIDTH}(DD)
                | GWINTTAG{DTIME_X+(6*TICK_WIDTH),DLWTIME_Y,2*TICK_WIDTH,2*TICK_WIDTH,DAY_STR}(DDW)
                |)
             |) where integer DD, DDW; end
          |)
         where 
         process GWINTTAG =
              { integer X_POS, Y_POS, DX, DY, STR_IND; }
              ( ? integer V;
              )
            (| C := V>=0
             | GWPTAG(X_POS,Y_POS,STR_IND+(V when C when CC))
             | CC := WCLEARAREA(X_POS when (^C),Y_POS-DY,DX,DY)
             |)
            where 
            boolean C, CC;
            end
         ; 
         process WUNIT4 =
              { integer X, Y, TICK_SIZE; }
              ( ? integer V;
              )
            (| WPINT4(X,Y,V when (V>=0) when CC)
             | CC := WCLEARAREA(X when (^V),Y-(2*TICK_SIZE),4*TICK_SIZE,2*TICK_SIZE)
             |)
            where 
            boolean CC;
            end
         ; 
         end
      ; 
      process WUNIT =
           { integer X, Y, TICK_SIZE; }
           ( ? integer V;
           )
         (| WPINT2(X,Y,V when (V>=0))
          | CC := WCLEARAREA(X when (^V),Y-(2*TICK_SIZE),2*TICK_SIZE,2*TICK_SIZE)
          |)
         where 
         boolean CC;
         end
      ; 
      process TIMESCREEN =
           { integer DTIME_X, DTIME_Y, PM_STR, TICK_WIDTH; }
           ( ? boolean DPM;
               integer DL, DM, DR;
           )
         (| WTAG{DTIME_X-(2*TICK_WIDTH),DTIME_Y-TICK_WIDTH,2*TICK_WIDTH,TICK_WIDTH,PM_STR}(DPM)
          | WUNIT{DTIME_X,DTIME_Y,TICK_WIDTH}(DL)
          | WUNIT{DTIME_X+(3*TICK_WIDTH),DTIME_Y,TICK_WIDTH}(DM)
          | WUNIT{DTIME_X+(6*TICK_WIDTH),DTIME_Y,TICK_WIDTH}(DR)
          |)
      ; 
      process WTAG =
           { integer X_POS, Y_POS, DX, DY, STR_IND; }
           ( ? boolean C;
           )
         (| WPTAG(X_POS when C when CC,Y_POS,STR_IND)
          | CC := WCLEARAREA(X_POS when (^C),Y_POS-DY,DX,DY)
          |)
         where 
         boolean CC;
         end
      ; 
      process WINTTAG =
           { integer X_POS, Y_POS, DX, DY; }
           ( ? integer STNB;
           )
         (| WDTAG(X_POS,Y_POS,STNB when CC)
          | CC := WCLEARAREA(X_POS when (^STNB),Y_POS-DY,DX,DY)
          |)
         where 
         boolean CC;
         end
      ; 
      end
   ; 
   process WACHAL =
        { integer PS, PISET, NAL; }
        ( ? event HS;
            event UL;
            event LL;
            event UR;
            event LR;
            event HF;
          ! integer STNB;
            event BEEP;
            integer DL;
            integer DM;
            integer DR;
            boolean DPM;
            integer LWMIN;
            integer LWHOUR;
            integer DDAY;
            integer DDAYOFW;
            integer DMONTH;
            integer DYEAR;
            boolean STATE24;
        )
      (| (| (| HELoic := HS
             | S_WATCH{PS,PISET,NAL}
             | BEEP := HALARM
             | DL := DHOUR
             | DM := DMIN
             | DR := DSEC
             | DPM := WDPM
             | STATE24 := D24H
             |) where event HELoic, HALARM;
                      integer DHOUR, DMIN, DSEC;
                      boolean WDPM, D24H; end
          | (| HE := HF
             | CONDUCTOR{}
             | STNB := DSTNB
             |) where event HE;
                      integer DSTNB; end
          |)/ ADIS, SWDIS, WDIS, AON, WON, SWON |)
      where 
      process WHEEL =
           { integer V_MODULO, V_0; }
           ( ? event RESET;
               event H;
             ! event HS;
               integer V;
           )
         (| (| (| ERESET := RESET
                | (| LocRESET := ERESET default HS
                   | V ^= ERESET default H
                   |)
                |) where event ERESET; end
             | (| ZV := V$1
                | V := (0 when LocRESET) default (ZV+1)
                | HS := when (ZV>=(V_MODULO-1))
                |)/ ZV
             |)/ LocRESET |)
         where 
         event LocRESET;
         integer ZV init V_0;
         end
      ; 
      process S_WATCH =
           { integer PS, PI, NBL; }
           ( ? event HELoic;
               event UL;
               event UR;
               event LR;
               boolean WDIS;
               event LL;
               boolean SWDIS;
               boolean ADIS;
             ! event HALARM;
               integer DDAYOFW;
               integer DDAY;
               integer DMONTH;
               integer DYEAR;
               integer DSEC;
               integer DMIN;
               boolean WDPM;
               integer DHOUR;
               event SWON;
               boolean D24H;
               integer LWMIN;
               integer LWHOUR;
               event WON;
               event AON;
           )
         (| (| (| HE := HELoic
                | WATCH{PS,PI,NBL}
                | WDPM := DPM
                | SWON := WOFF
                |) where event HE, WOFF;
                         boolean DPM; end/ WSETONOFF
             | (| ST := SWDIS
                | AOFF := LL when ST
                | WON := AOFF
                |) where boolean ST;
                         event AOFF; end
             | (| HOUR := CHOUR
                | MIN := CMIN
                | DISOFF := WON
                | DISON := SWON
                | LWDISPLAY{}
                | LWMIN := DMIN
                | LWHOUR := DHOUR
                |) where event DISON, DISOFF;
                         integer DMIN, DHOUR, MIN, HOUR; end
             | (| ST := ADIS
                | SWOFF := LL when ST
                | AON := SWOFF
                |) where boolean ST;
                         event SWOFF; end
             |)/ CHOUR, CMIN, STATE24 |)
         where 
         process LWDISPLAY =
              ( ? boolean STATE24;
                  integer MIN;
                  integer HOUR;
                  event DISON;
                  event DISOFF;
                ! boolean D24H;
                  integer DMIN;
                  integer DHOUR;
              )
            (| H := (^MIN) default (^HOUR) default DISON default DISOFF
             | (| VIS := (not DISOFF) default DISON default ZVIS
                | ZVIS := VIS$1
                | VIS ^= H
                |)
             | (| CMIN := MIN cell H
                | DMIN := (CMIN when DISON) default (MIN when VIS)
                |)
             | (| CHOUR := HOUR cell H
                | DHOUR := (CHOUR when DISON) default (HOUR when VIS)
                |)
             | (| CS24 := STATE24 cell DISOFF
                | D24H := CS24 default (not DISON)
                |)
             |)
            where 
            boolean VIS, ZVIS init false, CS24 init false;
            integer CMIN init 0, CHOUR init 0;
            event H;
            end
         ; 
         process D_12_24 =
              ( ? integer DV;
                  boolean SW24;
                ! boolean DPM;
                  integer DHOUR;
              )
            (| STATE24 := SW24 cell (^DV)
             | CV := DV cell (^STATE24)
             | DPM := ((CV>12) when (not STATE24)) default (not (^CV))
             | DHOUR := ((CV-12) when DPM) default CV
             |)
            where 
            integer CV init 0;
            boolean STATE24 init false;
            end
         ; 
         process WHILE =
              { boolean V_0; }
              ( ? boolean INTONOFF;
                  VIN;
                ! VOUT;
              )
            (| CSTATE := INTONOFF cell (^VIN)
             | VOUT := VIN when CSTATE
             |)
            where 
            boolean CSTATE init V_0;
            end
         ; 
         process SLOPE =
              { integer PISET, NAL; }
              ( ? event RESET;
                  event CLICK;
                  event TICK;
                ! event HINCR;
                  event HBLINK;
              )
            (| (| (| H := HS
                   | LTICK := TICK
                   | LCLICK := CLICK
                   | BEYOND{NAL}
                   |) where event LCLICK, LTICK, H; end
                | (| H := CLICK default TICK default RESET
                   | WHEEL{PISET,PISET-1}
                   |)/ V, H
                |)/ HS |)
            where 
            process BEYOND =
                 { integer SATURATION; }
                 ( ? event H;
                     event RESET;
                     event LTICK;
                     event LCLICK;
                   ! event HINCR;
                     event HBLINK;
                 )
               (| (| V ^= RESET default H
                   | (| ZV := V$1
                      | V := (0 when RESET) default (ZV+1)
                      | INCREASE := V<SATURATION
                      |)/ ZV
                   | (| HBLINK := LTICK when INCREASE
                      | HINCR := (LTICK when (not INCREASE)) default (LCLICK when INCREASE)
                      |)
                   |)/ INCREASE, V |)
               where 
               integer V, ZV init 0;
               boolean INCREASE;
               end
            ; 
            event H, HS;
            integer V;
            end
         ; 
         process WATCH =
              { integer PS, PI, NBL; }
              ( ? event WON;
                  boolean WDIS;
                  event UL;
                  event LL;
                  event UR;
                  event LR;
                  event HE;
                ! event WOFF;
                  boolean WSETONOFF;
                  event HALARM;
                  integer DDAY;
                  integer DYEAR;
                  integer DMONTH;
                  integer DDAYOFW;
                  boolean STATE24;
                  boolean DPM;
                  integer DSEC;
                  integer CMIN;
                  integer DMIN;
                  integer CHOUR;
                  integer DHOUR;
              )
            (| (| (| DON := WON
                   | WDISPATCH{}
                   | WOFF := DOFF
                   | STATE24 := SW24
                   |) where event DON, DOFF;
                            boolean SW24; end
                | (| SW24 := STATE24
                   | SETTIME{PS,PI,NBL}
                   |) where boolean SW24; end
                | SETDATE{PI,NBL}
                | (| SETWDAY{PI,NBL}
                   | DDAYOFW := DDOFW
                   |) where integer DDOFW; end
                |)/ DAY, MAXDAY, HDAY, TICK, CLICK, STATE, SETONOFF, DISONOFF |)
            where 
            process SETTIME =
                 { integer PS, PI, NBL; }
                 ( ? boolean SW24;
                     boolean DISONOFF;
                     boolean SETONOFF;
                     event TICK;
                     event CLICK;
                     integer STATE;
                     event HE;
                   ! event HDAY;
                     boolean DPM;
                     integer DHOUR;
                     integer CHOUR;
                     integer DMIN;
                     integer CMIN;
                     integer DSEC;
                 )
               (| (| (| SETONOFF1 := SETONOFF
                      | SETS{PS,PI}
                      | DSEC := DV
                      |) where boolean SETONOFF1;
                               integer DV; end
                   | (| HE := HMN
                      | SETU{1,60,PI,NBL}
                      | DMIN := DV
                      | CMIN := V
                      |) where integer DV, V;
                               event HE; end
                   | (| HHOUR := HS
                      | SETH{PI,NBL}
                      |) where event HHOUR; end
                   |)/ HS, HMN |)
               where 
               process SETS =
                    { integer PSEC, PI; }
                    ( ? boolean DISONOFF;
                        boolean SETONOFF1;
                        integer STATE;
                        event CLICK;
                        event TICK;
                        event HE;
                      ! integer DV;
                        event HMN;
                    )
                  (| (| UCONTROL{0}
                      | (| RESET2 := LCLICK
                         | SETONOFF := USETONOFF
                         | SMOTOR{PSEC}
                         | V_1 := V
                         |) where boolean SETONOFF;
                                  event RESET2;
                                  integer V; end
                      | (| HBL := HS
                         | V := V_1
                         | RESET1 := LCLICK
                         | SETONOFF := USETONOFF
                         | UDIS{true}
                         |) where boolean SETONOFF;
                                  event RESET1, HBL;
                                  integer V; end
                      | (| H := LTICK
                         | WHEEL{PI,PI-1}
                         |) where event H; end/ V
                      |)/ HS, V_1, LCLICK, USETONOFF, RESET, LTICK |)
                  where 
                  process SMOTOR =
                       { integer PSEC; }
                       ( ? boolean SETONOFF;
                           event RESET2;
                           event HE;
                         ! event HMN;
                           integer V;
                       )
                     (| HMN := WHILE{true}(not SETONOFF,LHMN)
                      | (LHMN,V) := WHEEL{60,59}(RESET2,LHSEC)
                      | (LHSEC,VV) := WHEEL{PSEC,PSEC-1}(RESET2,HE)
                      |)
                     where 
                     integer VV;
                     event LHMN, LHSEC;
                     end
                  ; 
                  event LTICK, RESET, LCLICK, HS;
                  boolean USETONOFF;
                  integer V_1, V;
                  end
               ; 
               process SETH =
                    { integer PI, NBL; }
                    ( ? boolean SW24;
                        boolean DISONOFF;
                        boolean SETONOFF;
                        event TICK;
                        event CLICK;
                        integer STATE;
                        event HHOUR;
                      ! boolean DPM;
                        integer DHOUR;
                        event HDAY;
                        integer CHOUR;
                    )
                  (| (| (| HE := HHOUR
                         | SETU{2,24,PI,NBL}
                         | HDAY := HS
                         | CHOUR := V
                         |) where event HE, HS;
                                  integer V; end
                      | D_12_24{}
                      |)/ DV |)
                  where 
                  integer DV;
                  boolean HTMIN;
                  end
               ; 
               event HMN, HS;
               end
            ; 
            process WDISPATCH =
                 ( ? event HE;
                     event DON;
                     event LL;
                     event UR;
                     event LR;
                     boolean WDIS;
                     integer DAY;
                     integer MAXDAY;
                     event UL;
                   ! event TICK;
                     boolean SETONOFF;
                     event CLICK;
                     boolean DISONOFF;
                     boolean SW24;
                     integer STATE;
                     event DOFF;
                     boolean WSETONOFF;
                     event HALARM;
                 )
               (| (| (| LL := SLL
                      | LR := SLR
                      | WFILTER{}
                      |) where event LR, LL; end
                   | (| SWITCH{false}
                      | SW24 := DB
                      |) where boolean DB; end
                   | (| INTONOFF := SETONOFF
                      | VIN := HE
                      | WHILE{false}
                      | TICK := VOUT
                      |) where event VIN, VOUT;
                               boolean INTONOFF; end
                   | (| SWISET := CWSET
                      | STATE := WDIS
                      | SELECT{}
                      | WSETONOFF := MODONOFF
                      |) where boolean STATE, MODONOFF, SWISET; end/ SUR
                   | CONTROL{}
                   |)/ CWSET, SLL, SLR, COMMUT |)
               where 
               boolean CWSET, SET init false;
               event SLL, SLR, H;
               process WFILTER =
                    ( ? boolean CWSET;
                        event DON;
                        event DOFF;
                        boolean WSETONOFF;
                        event LL;
                        event LR;
                      ! integer STATE;
                        boolean DISONOFF;
                        boolean SETONOFF;
                        event CLICK;
                        event COMMUT;
                    )
                  (| DISONOFF := DON default (not DOFF)
                   | SETONOFF := (not DON) default WSETONOFF
                   | (| HAUTO := LR default LL default DON default (^CWSET)
                      | CSET := SETONOFF default ZCSET
                      | ZCSET := CSET$1
                      | CSET ^= HAUTO
                      |)
                   | (| RESET := when SETONOFF
                      | XNEXT := LL when CSET
                      | CLICK := LR when CSET
                      |)
                   | (| VRESET := (4 when (not CWSET)) default (0 when RESET)
                      | (H,STATE) := DYN_WHEEL{7,0}(VRESET,XNEXT default (when CWSET))
                      |)
                   | COMMUT := LR when (not CSET)
                   |)
                  where 
                  integer VRESET;
                  event HAUTO, H, RESET, XNEXT;
                  boolean CSET, ZCSET init false;
                  end
               ; 
               process DYN_WHEEL =
                    { integer V_MODULO, V_0; }
                    ( ? integer VRESET;
                        event H;
                      ! event HS;
                        integer V;
                    )
                  (| (| (| IRESET := VRESET default (0 when HS)
                         | V ^= (^VRESET) default H
                         |)
                      | (| ZV := V$1
                         | V := IRESET default (ZV+1)
                         | HS := when (ZV>=(V_MODULO-1))
                         |)/ ZV
                      |)/ IRESET |)
                  where 
                  integer IRESET, ZV init V_0;
                  end
               ; 
               process CONTROL =
                    ( ? integer DAY;
                        integer MAXDAY;
                        boolean WDIS;
                        event UL;
                      ! event HALARM;
                        boolean CWSET;
                    )
                  (| (| (| ST := WDIS
                         | SUL := UL when ST
                         |) where boolean ST; end
                      | (| (| HALARM := SUL when CALARM
                            | CSWSET := (not CALARM) when SUL
                            |)
                         | CWSET := CSWSET
                         |) where boolean CSWSET; end
                      | (| ST := WDIS
                         | DAYCONTROL{}
                         |) where boolean ST; end
                      |)/ CALARM, SUL |)
                  where 
                  process DAYCONTROL =
                       ( ? boolean ST;
                           integer DAY;
                           integer MAXDAY;
                         ! boolean CALARM init false;
                       )
                     (| CDAY := DAY cell (^ST)
                      | CMAXDAY := MAXDAY cell (^CDAY)
                      | NCALARM := CDAY>=CMAXDAY
                      | CALARM := NCALARM$1 init false
                      |)
                     where 
                     boolean NCALARM;
                     integer CDAY init 0, CMAXDAY init 31;
                     end
                  ; 
                  event SUL;
                  boolean CALARM init false;
                  end
               ; 
               COMMUT, SUR;
               end
            ; 
            process UDIS =
                 { boolean C_DIS_0; }
                 ( ? boolean DISONOFF;
                     boolean SETONOFF;
                     integer V;
                     event HBL;
                     event RESET1;
                   ! integer DV;
                 )
               (| I_SET := (^V) default RESET1
                | C_DISONOFF := DISONOFF cell ((^SETONOFF) default I_SET default HBL)
                | H := ^C_DISONOFF
                | CV := V cell H
                | DV2 := CV when DISONOFF
                | DV3 := CV when (^SETONOFF)
                | (| ACTIF := I_SET default (not ZACTIF)
                   | ZACTIF := ACTIF$1
                   | ACTIF ^= I_SET default HBL
                   | DV4 := (CV when ACTIF) default ((-2) when (not ACTIF))
                   |)
                | DV := (V default DV2 default DV3 default DV4) when C_DISONOFF
                |)
               where 
               event H, I_SET;
               boolean ACTIF, ZACTIF init false, C_DISONOFF init C_DIS_0;
               integer CV init 0, DV2, DV3, DV4;
               end
            ; 
            process FILTER =
                 { integer N, PISET, NAL; }
                 ( ? event HE;
                     integer STATE;
                     boolean SETONOFF;
                     event CLICK;
                     event TICK;
                   ! event HEXT;
                     boolean USETONOFF;
                     event HRESET;
                     event HINCR;
                     event HBLINK;
                 )
               (| (| (| SETONOFF1 := SETONOFF
                      | UCONTROL{N}
                      | RESET_1 := RESET
                      |) where boolean SETONOFF1;
                               event RESET; end
                   | (| TICK := LTICK
                      | CLICK := LCLICK
                      | RESET := HRESET
                      | SLOPE{PISET,NAL}
                      |) where event RESET, CLICK, TICK; end
                   | (| CSET := USETONOFF
                      | HEXT := WHILE{true}(not CSET,HE)
                      |) where boolean CSET; end
                   | (| RESET := RESET_1
                      | HRESET := RESET default LCLICK
                      |) where event RESET; end
                   |)/ LTICK, LCLICK, RESET_1 |)
               where 
               event RESET_1, RESET, LCLICK, LTICK;
               end
            ; 
            process SETU =
                 { integer N, P, PI, NBL; }
                 ( ? boolean DISONOFF;
                     boolean SETONOFF;
                     integer STATE;
                     event CLICK;
                     event TICK;
                     event HE;
                   ! integer DV;
                     integer V;
                     event HS;
                 )
               (| (| FILTER{N,PI,NBL}
                   | (| HE := HEXT
                      | HL := HINCR
                      | SETONOFF := USETONOFF
                      | USET{P}
                      |) where boolean SETONOFF;
                               event HL, HE; end
                   | (| SETONOFF := USETONOFF
                      | HBL := HBLINK
                      | RESET1 := HRESET
                      | UDIS{N<5}
                      |) where event RESET1, HBL;
                               boolean SETONOFF; end
                   |)/ HEXT, HINCR, USETONOFF, HBLINK, HRESET |)
               where 
               process USET =
                    { integer P; }
                    ( ? boolean SETONOFF;
                        event HL;
                        event HE;
                      ! event HS;
                        integer V;
                    )
                  (| (H,V) := EVERY{P,P-1}(HL default HE)
                   | HS := WHILE{true}(not SETONOFF,H)
                   |)
                  where 
                  event H;
                  end
               ; 
               event HRESET, HBLINK, HINCR, HEXT;
               boolean USETONOFF;
               end
            ; 
            process UCONTROL =
                 { integer N; }
                 ( ? integer STATE;
                     boolean SETONOFF1;
                     event CLICK;
                     event TICK;
                   ! boolean USETONOFF;
                     event RESET;
                     event LCLICK;
                     event LTICK;
                 )
               (| USETONOFF := (STATE=N) default SETONOFF1
                | CSET := USETONOFF cell (CLICK default TICK)
                | RESET := when (STATE=N)
                | LCLICK := CLICK when CSET
                | LTICK := TICK when CSET
                |)
               where 
               boolean CSET init false;
               end
            ; 
            process SETDATE =
                 { integer PI, NBL; }
                 ( ? boolean DISONOFF;
                     event HDAY;
                     boolean SETONOFF;
                     integer STATE;
                     event CLICK;
                     event TICK;
                   ! integer DDAY;
                     integer DAY;
                     integer DMONTH;
                     integer DYEAR;
                     integer MAXDAY;
                 )
               (| (| SETDAY{PI,NBL}
                   | SETMAXDAY{}
                   | SETMY{PI,NBL}
                   |)/ MONTH, YEAR, LEAP_CENTURY, HMONTH |)
               where 
               process SETMAXDAY =
                    ( ? event HDAY;
                        event CLICK;
                        event TICK;
                        integer MONTH;
                        integer YEAR;
                        boolean LEAP_CENTURY;
                      ! integer MAXDAY;
                    )
                  (| H := HDAY default CLICK default TICK
                   | MAX_S_MONTH := 30 when ((MONTH=3) or (MONTH=5) or (MONTH=8) or (MONTH=10))
                   | BISSEXT := MOD(YEAR,4)=0
                   | CMAXFEB := ((28 when (not LEAP_CENTURY)) default (29 when BISSEXT) default (28 when (not BISSEXT))) cell H
                   | CMONTH := MONTH cell H
                   | MAXFEB := CMAXFEB when ((when (MONTH=1)) default ((^YEAR) when (CMONTH=1)))
                   | NMAXDAY := ((MAX_S_MONTH default MAXFEB default (31 when (^MONTH))) when H) default MAXDAY
                   | MAXDAY := NMAXDAY$1 init 31
                   | MAXDAY ^= H
                   |)
                  where 
                  integer MAX_S_MONTH, MAXFEB, CMAXFEB init 28, NMAXDAY, CMONTH init 0;
                  boolean BISSEXT init true;
                  event H;
                  function MOD =
                       ( ? integer V;
                           integer VMOD;
                         ! integer SV;
                       )
                  
                  ; 
                  end
               ; 
               process SETMY =
                    { integer PI, NBL; }
                    ( ? event HMONTH;
                        integer STATE;
                        boolean SETONOFF;
                        event CLICK;
                        event TICK;
                      ! integer DMONTH;
                        integer MONTH;
                        integer DYEAR;
                        boolean LEAP_CENTURY;
                        integer YEAR;
                    )
                  (| (| CONTROL{}
                      | (| DISONOFF := DONOFF
                         | SETY{PI,NBL}
                         |) where boolean DISONOFF; end
                      | (| DISONOFF := DONOFF
                         | SETM{PI,NBL}
                         |) where boolean DISONOFF; end
                      |)/ HYEAR, DONOFF |)
                  where 
                  process SETY =
                       { integer PISET, NBL; }
                       ( ? boolean DISONOFF;
                           boolean SETONOFF;
                           integer STATE;
                           event CLICK;
                           event TICK;
                           event HYEAR;
                         ! integer YEAR;
                           boolean LEAP_CENTURY;
                           integer DYEAR;
                       )
                     (| (DV,YEAR,HC) := YSET{PISET,NBL}(DISONOFF,SETONOFF,STATE,CLICK,TICK,HYEAR)
                      | SDYEAR := DV default ((-2) when (not DISONOFF))
                      | LEAP_CENTURY := SWITCH{true}(HC)
                      | CLEAP_CENTURY := LEAP_CENTURY cell (^SDYEAR)
                      | DYEAR := ((-2) when (SDYEAR<0)) default ((SDYEAR+2000) when CLEAP_CENTURY) default (SDYEAR+1900)
                      |)
                     where 
                     event HC;
                     boolean CLEAP_CENTURY init false;
                     integer DV, CDV init 0, SDYEAR;
                     process YSET =
                          { integer PI, NBL; }
                          ( ? boolean DISONOFF;
                              boolean SETONOFF;
                              integer STATE;
                              event CLICK;
                              event TICK;
                              event HE;
                            ! integer DV;
                              integer V;
                              event HS;
                          )
                        (| (| FILTER{6,PI,NBL}
                            | (| HE := HEXT
                               | HL := HINCR
                               | (HS,V) := EVERY{100,99}(HL default HE)
                               |) where event HL, HE; end
                            | (| SETONOFF := USETONOFF
                               | HBL := HBLINK
                               | RESET1 := HRESET
                               | UDIS{false}
                               |) where event RESET1, HBL;
                                        boolean SETONOFF; end
                            |)/ HEXT, HINCR, USETONOFF, HBLINK, HRESET |)
                        where 
                        event HRESET, HBLINK, HINCR, HEXT;
                        boolean USETONOFF;
                        end
                     ; 
                     end
                  ; 
                  process SETM =
                       { integer PI, NBL; }
                       ( ? event HMONTH;
                           integer STATE;
                           event CLICK;
                           event TICK;
                           boolean SETONOFF;
                           boolean DISONOFF;
                         ! integer MONTH;
                           event HYEAR;
                           integer DMONTH;
                       )
                     (| (DV,MONTH,HYEAR) := SETU{5,12,PI,NBL}(DISONOFF,SETONOFF,STATE,CLICK,TICK,HMONTH)
                      | DMONTH := DV default ((-2) when (not DISONOFF))
                      |)
                     where 
                     integer DV, DVERR init 1;
                     end
                  ; 
                  process CONTROL =
                       ( ? boolean SETONOFF;
                           integer STATE;
                         ! boolean DONOFF;
                       )
                     (| DONOFF := (not (^SETONOFF)) default (STATE>=3) |)
                  ; 
                  boolean DONOFF;
                  event HYEAR;
                  end
               ; 
               process SETDAY =
                    { integer PI, NBL; }
                    ( ? boolean DISONOFF;
                        integer STATE;
                        event CLICK;
                        event TICK;
                        event HDAY;
                        boolean SETONOFF;
                        integer MAXDAY;
                      ! integer DDAY, DAY;
                        event HMONTH;
                    )
                  (| (| (| HE := HDAY
                         | FILTER{4,PI,NBL}
                         |) where event HE; end
                      | (| HAD := HEXT
                         | HSD := HINCR
                         | SETONOFF := USETONOFF
                         | DSET{}
                         |) where boolean SETONOFF;
                                  event HSD, HAD; end
                      | (| SETONOFF := USETONOFF
                         | RESET1 := HRESET
                         | HBL := HBLINK
                         | V := DAY
                         | (| DDAY := DV+1
                            | UDIS{true}
                            |)
                         |) where integer V;
                                  event HBL, RESET1;
                                  boolean SETONOFF; end/ DV
                      |)/ HEXT, HINCR, USETONOFF, HRESET, HBLINK |)
                  where 
                  process DSET =
                       ( ? boolean SETONOFF;
                           integer MAXDAY;
                           event HSD;
                           event HAD;
                         ! event HMONTH;
                           integer DAY;
                       )
                     (| HDAY := HSD default HAD
                      | TMAXDAY := (MAXDAY cell HDAY) when HDAY
                      | (LHMONTH,DAY) := DYN_EVERY{30}(HDAY,TMAXDAY)
                      | HMONTH := WHILE{true}(not SETONOFF,LHMONTH)
                      |)
                     where 
                     integer TMAXDAY init 31;
                     event LHMONTH, HDAY;
                     end
                  ; 
                  event HBLINK, HRESET, HINCR, HEXT;
                  boolean USETONOFF;
                  integer DV;
                  end
               ; 
               event HMONTH;
               LEAP_CENTURY, YEAR, MONTH;
               end
            ; 
            process SETWDAY =
                 { integer PI, NBL; }
                 ( ? event HDAY;
                     integer STATE;
                     event CLICK;
                     event TICK;
                     boolean SETONOFF;
                     boolean DISONOFF;
                   ! integer DDOFW;
                 )
               (| (DDOFW,V,HS) := SETU{3,7,PI,NBL}(DISONOFF,SETONOFF,STATE,CLICK,TICK,HDAY) |)
               where 
               event HS;
               integer V;
               end
            ; 
            boolean DISONOFF, SETONOFF;
            integer STATE, MAXDAY, DAY;
            event CLICK, TICK, HDAY;
            end
         ; 
         process SELECT =
              ( ? boolean SWISET;
                  boolean STATE;
                  event UR;
                  event LR;
                  event LL;
                ! boolean MODONOFF;
                  event SLL;
                  event DOFF;
                  event SLR;
                  event SUR;
              )
            (| (| (| ST := STATE
                   | (| SUR := UR when ST
                      | SLR := LR when ST
                      | XLL := LL when ST
                      |)
                   |) where boolean ST; end
                | (| ST := STATE
                   | SWSET := SWISET
                   | (| MODE ^= when ST
                      | MODONOFF := (not ZMODE) when SWSET
                      | MODE := MODONOFF default ZMODE
                      | ZMODE := MODE$1
                      | OFF := XLL when (not MODE)
                      | SLL := XLL when MODE
                      |)
                   | DOFF := OFF
                   |) where boolean SWSET, ST;
                            event OFF; end/ ZMODE
                                          / MODE
                |)/ XLL |)
            where 
            event XLL;
            boolean ZMODE init false, MODE;
            end
         ; 
         boolean WSETONOFF, STATE24;
         integer CMIN, CHOUR;
         end
      ; 
      process CONDUCTOR =
           ( ? event WON;
               event SWON;
               event AON;
               event HE;
             ! integer DSTNB;
               boolean WDIS;
               boolean SWDIS;
               boolean ADIS;
           )
         (| (| H := HE
             | (| CST := NST cell H
                | STNB := CST$1 init 0
                | (HS1,NST) := EVERY{3,0}(AON default SWON default WON)
                | WDIS := STNB=0
                | SWDIS := STNB=1
                | ADIS := STNB=2
                |)
             | DSTNB := NST
             |) where event H;
                      integer NST; end/ CST
                                      / STNB
                                      / HS1 |)
         where 
         integer CST init 0, STNB;
         event HS1;
         end
      ; 
      event SWON, WON;
      AON, WDIS, SWDIS, ADIS;
      end
   ; 
   process SIGBELL =
        ( ? integer PERCENT;
        )
   
   ; 
   event BEEP, TBEEP, HCHRONO, HSLOW, SUL, SLL, SUR, SLR, ULLULR;
   integer LWMIN, LWHOUR, DDAY, DDAYOFW, DMONTH, DYEAR, DL, DM, DR, STNB;
   boolean DPM, STATE24;
   end
; 
