module GraphicLib =
   process GWPTAG =
        ( ? integer X;
            integer Y;
            integer STR;
        )
        spec (| X ^= Y ^= STR |)
   
   ; 
   process WPINT2 =
        ( ? integer X;
            integer Y;
            integer V;
        )
        spec (| X ^= Y ^= V |)
   
   ; 
   process WCLEARAREA =
        ( ? integer X1;
            integer Y1;
            integer X2;
            integer Y2;
          ! boolean CC;
        )
        spec (| X1 ^= Y1 ^= X2 ^= Y2 ^= CC |)
   
   ; 
   process WPTAG =
        ( ? integer X;
            integer Y;
            integer STR;
        )
        spec (| X ^= Y ^= STR |)
   
   ; 
   process WDTAG =
        ( ? integer X;
            integer Y;
            integer STR;
        )
        spec (| X ^= Y ^= STR |)
   
   ; 
   process WPINT4 =
        ( ? integer X;
            integer Y;
            integer V;
        )
        spec (| X ^= Y ^= V |)
   
   ; 
   process WVLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= Y2 |)
   
   ; 
   process WHLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 |)
   
   ; 
   process WEFFACE =
        ( ? integer SCREEN;
            integer X1;
            integer DX;
            integer DY;
        )
        spec (| SCREEN ^= X1 ^= DX ^= DY |)
   
   ; 
   process WLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 ^= Y2 |)
   
   ; 
   process WRECT =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 ^= Y2 |)
   
   ; 
   process WSTRING =
        ( ? integer SCREEN;
            integer CH;
            integer X;
            integer Y;
        )
        spec (| SCREEN ^= CH ^= Y ^= X |)
   
   ; 
end %GraphicLib%; 
